package org.wso2.solutions.identity.admin;

import org.wso2.solutions.identity.IdentityConstants;
import org.wso2.solutions.identity.IdentityProviderConstants;
import org.wso2.solutions.identity.IdentityProviderException;
import org.wso2.solutions.identity.UserStore;
import org.wso2.usermanager.Realm;
import org.wso2.usermanager.UserManagerException;
import org.wso2.usermanager.verification.email.EmailVerifier;
import org.wso2.usermanager.verification.email.EmailVerifierConfig;
import org.wso2.utils.ServerConfiguration;

public class EmailActivatorAdmin {


    public void createParamsAndInstanciateEmailVerifier(String port,
            String host, String fromAddress, String username, String password)
            throws IdentityProviderException {
        ParameterAdmin admin = new ParameterAdmin();
        admin.createOrUpdatearameter(
                IdentityProviderConstants.PARAM_NAME_EMAIL_PORT, port);
        admin.createOrUpdatearameter(
                IdentityProviderConstants.PARAM_NAME_EMAIL_HOST, host);
        admin.createOrUpdatearameter(
                IdentityProviderConstants.PARAM_NAME_EMAIL_FROM_ADDRESS,
                fromAddress);

        ServerConfiguration serverConfig = ServerConfiguration.getInstance();

        String hostName = serverConfig.getFirstProperty("HostName");
        String hostPort = serverConfig.getFirstProperty("Ports.HTTPS");

        String verificationAddress = "https://" + hostName + ":" + hostPort
                + IdentityConstants.USER_VERIFICATION_PAGE;

        admin.createOrUpdatearameter(
                IdentityProviderConstants.PARAM_NAME_EMAIL_VERIFICATION_EPR,
                verificationAddress);

        if (username.length() != 0) {
            admin.createOrUpdatearameter(
                    IdentityProviderConstants.PARAM_NAME_EMAIL_USERNAME,
                    username);
            admin.createOrUpdatearameter(
                    IdentityProviderConstants.PARAM_NAME_EMAIL_PASSWORD,
                    password);
        }

        admin.createOrUpdatearameter(
                IdentityProviderConstants.PARAM_NAME_ENABLE_EMAIL_VERIFICATION,
                null);
        
        EmailVerifierConfig config = new EmailVerifierConfig();
        config.setFromAddress(fromAddress);
        config.setHost(host);
        if (username.length() != 0) {
            config.setPassword(password);
            config.setUsername(username);
        }
        config.setRegistrationServiceEPR(verificationAddress);
        config.setPort(Integer.parseInt(port));
        
        Realm realm = UserStore.getInstance().getRealm();
        
        try {
            EmailVerifier.init(realm, config);
        } catch (UserManagerException e) {
            throw new IdentityProviderException("emailNotActivated");
        }
        
    }
}
