package org.wso2.solutions.identity.admin;

import org.wso2.solutions.identity.IdentityProviderException;
import org.wso2.solutions.identity.persistence.IPPersistenceManager;
import org.wso2.solutions.identity.persistence.dataobject.ParameterDO;

public class ParameterAdmin {

    IPPersistenceManager dbman;

    public ParameterAdmin() throws IdentityProviderException {
        dbman = IPPersistenceManager.getPersistanceManager();
    }

    public void createOrUpdatearameter(String name, String value)
            throws IdentityProviderException {
        if (name == null) {
            throw new IdentityProviderException("nullData");
        }
        name = name.trim();
        ParameterDO param = new ParameterDO();
        param.setName(name);
        if (value != null) {
            param.setValue(value);
        }
        dbman.createOrUpdateParameter(param);
    }

    public ParameterDO getParameter(String name) {
        ParameterDO param = dbman.getParameter(name);
        return param;
    }

    public String getParameterValue(String name) {
        String value = null;
        ParameterDO param = dbman.getParameter(name);
        if (param != null) {
            value = param.getValue();
        }
        return value;
    }

    public void removeParam(String name) throws IdentityProviderException {
        if (name == null) {
            throw new IdentityProviderException("nullData");
        }
        name = name.trim();

        String stmt = "delete ParameterDO where name = :nameValue";
        dbman.executeSingleDMLStatement(stmt, "nameValue", name);
    }

}
