package org.wso2.solutions.identity.admin;

import java.util.Date;
import java.util.List;

import org.wso2.solutions.identity.IdentityProviderException;
import org.wso2.solutions.identity.persistence.IPPersistenceManager;
import org.wso2.solutions.identity.persistence.dataobject.ActionDO;
import org.wso2.solutions.identity.persistence.dataobject.IssuedTokensDO;
import org.wso2.solutions.identity.report.OpenIDSummaryReportData;
import org.wso2.solutions.identity.report.ReportUtil;

public class ReportAdmin {

    public static void record(String username, String actionId, String details)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        dbman.addReportData(username, actionId, details);
    }

    public List getUserActionsByUser(String username, Date fromDate, Date toDate)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        return dbman.getUserActionsByUser(username, fromDate, toDate);
    }

    public List getFailedCardIssueActions(Date fromDate, Date toDate)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        return dbman.getReportDataByAction(ActionDO.ACTION_CARD_ISSUE_FAILURE,
                fromDate, toDate);

    }

    public List getFailedTokenIssueActions(Date fromDate, Date toDate)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        return dbman.getReportDataByAction(ActionDO.ACTION_TOKEN_ISSUE_FAILURE,
                fromDate, toDate);
    }

    // summary reports
    public List getCardIdsGroupedByUser() throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        return dbman.getCardIdsGroupedByUser();
    }

    public List getTokensGroupedByCardId() throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        List lst = dbman.getTokensGroupedByCardId();
        return lst;
    }

    public List getTokensGroupedByCardAndUser()
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        List lst = dbman.getTokensGroupedByCardAndUser();
        return lst;
    }

    public List getTokensGroupedByUser() throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        List lst = dbman.getTokensGroupedByUser();
        return lst;
    }
    
    public List<OpenIDSummaryReportData> getOpenIDsGroupedByUser() throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        return dbman.getOpenIDsGroupedByUser();
    }

    // /////////////////////////// Detailed reports

    public List getCardDetailsForUser(String userId)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        List lst = ReportUtil.convertToICReportData(dbman
                .getCardIdsForUser(userId));
        return lst;
    }

    public List getTokenDetailsForUser(String userId)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        IssuedTokensDO[] arr = dbman.getTokensForUser(userId);
        List lst = ReportUtil.convertToTokDetailsForUser(arr);
        return lst;
    }

    public List getTokenDetailsForCardId(String cardId)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        IssuedTokensDO[] arr = dbman.getTokenDetailsForCardId(cardId);
        List lst = ReportUtil.convertToTokDetailsForCardId(arr);
        return lst;
    }

    public List getTokenDetailsForCardAndUser(String cardId, String userId)
            throws IdentityProviderException {
        IPPersistenceManager dbman = IPPersistenceManager
                .getPersistanceManager();
        IssuedTokensDO[] arr = dbman.getTokenDetailsForCardAndUser(cardId,
                userId);
        List lst = ReportUtil.convertToTokDetailsForCardAndUser(arr);
        return lst;
    }
}
