/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.cards.model;

import org.wso2.solutions.identity.i18n.Messages;

public class CardModelException extends Exception {

    private static final long serialVersionUID = 3683874485305338092L;

    public final static String DEFAULT = "default";

    public final static String REQUIRED_ELEMENT_MISSING = "requiredElemMissing";

    public final static String REQUIRED_ATTRIBUTE_MISSING = "requiredAttrMissing";

    private static Messages messages = Messages
            .getInstance("org.wso2.solutions.identity.cards.model.resources");

    public CardModelException(String key, Object[] args) {
        super(messages.getMessage(key, args));
    }

    public CardModelException(String key) {
        this(key, (Object[]) null);
    }

    public CardModelException(String key, Object[] args, Throwable e) {
        super(messages.getMessage(key, args), e);
    }

    public CardModelException(String key, Throwable e) {
        this(key, null, e);
    }
}
