/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.cards.model;

import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axis2.addressing.AddressingConstants;

import javax.xml.namespace.QName;

public class Metadata implements CardElement {

    public final static String MEX_NS = "http://schemas.xmlsoap.org/ws/2004/09/mex";

    public final static String MEX_REFIX = "wsx";

    public final static QName NAME = new QName(MEX_NS, "Metadata", MEX_REFIX);

    private String address;

    public Metadata(String address) {
        this.address = address;
    }

    public OMElement serialize() throws CardModelException {

        OMFactory fac = OMAbstractFactory.getOMFactory();
        OMElement elem = fac.createOMElement(NAME);

        OMElement metadataSectionElem = fac.createOMElement(new QName(MEX_NS,
                "MetadataSection", MEX_REFIX), elem);
        metadataSectionElem.addAttribute(fac.createOMAttribute("Dialect", null,
                "http://schemas.xmlsoap.org/ws/2004/09/mex"));

        OMElement metadataRefElem = fac.createOMElement(new QName(MEX_NS,
                "MetadataReference", MEX_REFIX), metadataSectionElem);

        OMElement addressElem = fac.createOMElement(new QName(
                AddressingConstants.Final.WSA_NAMESPACE, "Address",
                AddressingConstants.WSA_DEFAULT_PREFIX), metadataRefElem);
        addressElem.setText(this.address);

        return elem;
    }

}
