/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.cards.model;

import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.wso2.solutions.identity.IdentityConstants;

import javax.xml.namespace.QName;

public class PrivacyNotice implements CardElement {

    public final static QName NAME = new QName(IdentityConstants.NS,
            "InformationCardReference", IdentityConstants.PREFIX);

    private final static String ATTR_VERSION = "Version";

    private String noticeUri;

    private int version = 0;

    public OMElement serialize() throws CardModelException {
        OMFactory fac = OMAbstractFactory.getOMFactory();
        OMElement elem = fac.createOMElement(NAME);

        elem.setText(this.noticeUri);

        if (version > 0) {
            elem.addAttribute(ATTR_VERSION, Integer.toString(this.version),
                    null);
        }

        return elem;
    }

    public String getNoticeUri() {
        return noticeUri;
    }

    public void setNoticeUri(String noticeUri) {
        this.noticeUri = noticeUri;
    }

    public int getVersion() {
        return version;
    }

    public void setVersion(int version) {
        this.version = version;
    }

}
