/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.i18n;

import java.text.MessageFormat;
import java.util.HashMap;
import java.util.ResourceBundle;

public class Messages {

    private static HashMap messagesCache = new HashMap();

    private ResourceBundle messages;

    private Messages(ResourceBundle messages) {
        this.messages = messages;
    }

    public static Messages getInstance(String name) {
        ResourceBundle rb = null;
        if (messagesCache.containsKey(name)) {
            rb = (ResourceBundle) messagesCache.get(name);
        } else {
            rb = ResourceBundle.getBundle(name);
            messagesCache.put(name, rb);
        }

        return new Messages(rb);
    }

    public String getMessage(String key, Object[] args) {
        return MessageFormat.format(this.messages.getString(key), args);
    }

    public String getMessage(String key) {
        return this.messages.getString(key);
    }
}
