/*
 * Copyright 2005-2008 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.openid.infocard;

import org.openid4java.infocard.OpenIDToken;
import org.openid4java.message.Message;

public class OpenIDInfoCardToken extends OpenIDToken {

    /**
     * Constructs an OpenID token encapsulating the provided OpenID Message.
     * Should be used on the OP/STS side to generate a RSTR.
     * @param openidMessage The OpenID message obtained from
     *                ServerManager.authResponse().
     */
    public OpenIDInfoCardToken(Message openidMessage) {
        super(openidMessage);

    }

    /**
     * Returns a well-formatted string token corresponding to the parameter
     * list.
     */
    public String getToken() {
        return getOpenIDMessage().keyValueFormEncoding();
    }

}
