/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.solutions.identity.persistence.dao;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.DialectDO;

import java.util.List;

public class DialectDAO extends BaseDAO {

    public DialectDAO(HibernateConfig config) {
        super(config);
    }

    public DialectDO[] getAllDialects() {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from DialectDO";

        DialectDO[] dialects = new DialectDO[0];
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            dialects = (DialectDO[]) lst.toArray(new DialectDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingDialects");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }

        return dialects;
    }

    public DialectDO getDialect(String uri) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from DialectDO as dialect where dialect.dialectUri = '"
                + uri + "'";

        DialectDO dialect = null;
        try {
            dialect = (DialectDO) session.createQuery(stmt).uniqueResult();
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingDialects");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }

        return dialect;
    }

}
