/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.solutions.identity.persistence.dao;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.InfoCardDO;
import org.wso2.solutions.identity.report.SummaryReportData;

public class InfoCardDAO extends BaseDAO {

    public InfoCardDAO(HibernateConfig config) {
        super(config);
    }

    public InfoCardDO[] getCardIdsForUser(String username) {

        String stmt = "from InfoCardDO where userId = '" + username + "'";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        InfoCardDO[] cards = new InfoCardDO[0];
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            cards = (InfoCardDO[]) lst.toArray(new InfoCardDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg =  messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return cards;
    }
    
    //cardCount, userId
    public List getCardIdsGroupedByUser() {

        String stmt = "select count(ic), ic.userId from InfoCardDO ic group by ic.userId";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        
        List datas = new ArrayList();
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            Iterator ite = lst.iterator();
            while(ite.hasNext()){
                Object[] tuple = (Object[])ite.next();
                Integer count = (Integer)tuple[0];
                String userId = (String)tuple[1];
                SummaryReportData data = new SummaryReportData();
                data.setCardCount(count.intValue());
                data.setUserId(userId);
                datas.add(data);
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg =  messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return datas;
    }

    public InfoCardDO[] getAllIssuedCards() {
        String stmt = "from InfoCardDO";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        InfoCardDO[] cards = null;
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            cards = (InfoCardDO[]) lst.toArray(new InfoCardDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return cards;
    }

    public InfoCardDO getInfoCard(String cardId) {
        String stmt = "from InfoCardDO where cardId = '" + cardId + "'";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        InfoCardDO card = null;
        try {
            card = (InfoCardDO) session.createQuery(stmt).uniqueResult();
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return card;
    }


    public void backupExpiredCards() {
        // TODO
    }
    

}
