package org.wso2.solutions.identity.persistence.dao;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.hibernate.Hibernate;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.IdentityProviderException;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.IssuedTokensDO;
import org.wso2.solutions.identity.report.SummaryReportData;

public class IssuedTokenDAO
        extends BaseDAO {

    public IssuedTokenDAO(HibernateConfig config) {
        super(config);
    }
 /*   
    public IssuedTokensDO[] getAllTokensOfUser(String username) {
        String stmt = "from IssuedTokensDO as val where val.userId = '"
                + username + "'";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        IssuedTokensDO[] tokens = null;
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            tokens = (IssuedTokensDO[]) lst.toArray(new IssuedTokensDO[lst
                    .size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingIsssuedTokensData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return tokens;
    }
    */

    public IssuedTokensDO[] getTokensForUser(String userId){

        String stmt = "from IssuedTokensDO as val where val.card.userId = '"
            + userId + "'";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        IssuedTokensDO[] toks = new IssuedTokensDO[0];
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            toks = (IssuedTokensDO[]) lst.toArray(new IssuedTokensDO[lst.size()]);
            for(int i=0;i<toks.length;i++){
                Hibernate.initialize(toks[i].getCard());
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return toks;
    }

    public IssuedTokensDO[] getTokenDetailsForCardId(String cardId){

        String stmt = "from IssuedTokensDO as val where val.card.cardId = '" + cardId
                + "'";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        IssuedTokensDO[] toks = new IssuedTokensDO[0];
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            toks = (IssuedTokensDO[]) lst.toArray(new IssuedTokensDO[lst.size()]);
            for(int i=0;i<toks.length;i++){
                Hibernate.initialize(toks[i].getCard());
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return toks;
    }

    public IssuedTokensDO[] getTokenDetailsForCardAndUser(String cardId,
            String userId) throws IdentityProviderException {
        String stmt = "from IssuedTokensDO as val where val.card.cardId = '" + cardId
                + "' and val.card.userId = '" + userId + "'";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        IssuedTokensDO[] toks = new IssuedTokensDO[0];
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            toks = (IssuedTokensDO[]) lst.toArray(new IssuedTokensDO[lst.size()]);
            for(int i=0;i<toks.length;i++){
                Hibernate.initialize(toks[i].getCard());
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return toks;
    }

    public List getTokensGroupedByUser() {
        String stmt = "select count(tok), tok.card.userId from IssuedTokensDO tok group by tok.card.userId";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        List datas = new ArrayList();
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            Iterator ite = lst.iterator();
            while (ite.hasNext()) {
                Object[] tuple = (Object[]) ite.next();
                Integer count = (Integer) tuple[0];
                String userId = (String) tuple[1];
                SummaryReportData data = new SummaryReportData();
                data.setTokenCount(count.intValue());
                data.setUserId(userId);
                datas.add(data);
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return datas;
    }

    public List getTokensGroupedByCardId() {
        String stmt = "select count(tok), tok.card.cardId from IssuedTokensDO tok group by tok.card.cardId";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        List datas = new ArrayList();
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            Iterator ite = lst.iterator();
            while (ite.hasNext()) {
                Object[] tuple = (Object[]) ite.next();
                Integer count = (Integer) tuple[0];
                String cardId = (String) tuple[1];
                SummaryReportData data = new SummaryReportData();
                data.setTokenCount(count.intValue());
                data.setCardId(cardId);
                datas.add(data);
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return datas;
    }

    public List getTokensGroupedByCardAndUser() {
        String stmt = "select count(tok), tok.card.userId, tok.card.cardId from IssuedTokensDO tok group by tok.card.userId, tok.card.cardId";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        List datas = new ArrayList();
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            Iterator ite = lst.iterator();
            while (ite.hasNext()) {
                Object[] tuple = (Object[]) ite.next();
                Integer count = (Integer) tuple[0];
                String userId = (String) tuple[1];
                String cardId = (String) tuple[2];
                SummaryReportData data = new SummaryReportData();
                data.setTokenCount(count.intValue());
                data.setUserId(userId);
                data.setCardId(cardId);
                datas.add(data);
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingInfoCardData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return datas;
    }

}
