/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.solutions.identity.persistence.dao;

import org.hibernate.Hibernate;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.PPIDValueDO;

import java.util.List;

public class PPIDValueDAO extends BaseDAO {

    public PPIDValueDAO(HibernateConfig config) {
        super(config);
    }

    public PPIDValueDO[] getPPIDValuesForUser(String userId) {
        String stmt = "from PPIDValueDO as val where val.userId = '" + userId
                + "'";

        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        PPIDValueDO[] ppids = null;
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            ppids = (PPIDValueDO[]) lst.toArray(new PPIDValueDO[lst.size()]);
            for(int i=0; i< ppids.length; i++){
                Hibernate.initialize(ppids[i].getPersonalRelyingParty());
                Hibernate.initialize(ppids[i].getRelyingParty());
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingPPIDValue");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        
        return ppids;
    }

    public PPIDValueDO[] getAllPPIDs() {

        String stmt = "from PPIDValueDO";

        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();

        PPIDValueDO[] ppids = null;
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            ppids = (PPIDValueDO[]) lst.toArray(new PPIDValueDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingPPIDValue");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return ppids;
    }


}
