/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.solutions.identity.persistence.dao;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.PersistentObjectException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.ParameterDO;

public class ParameterDAO extends BaseDAO {

	protected Log log = LogFactory.getLog(ParameterDAO.class);

    public ParameterDAO(HibernateConfig config) {
        super(config);
    }

    public ParameterDO[] readAllConfigs() {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from ParameterDO";
        ParameterDO[] pa = null;
        try {
            Query query = session.createQuery(stmt);

            Iterator ite = query.iterate();
            List lst = new ArrayList();
            while (ite.hasNext()) {
                lst.add(ite.next());
            }
            pa = (ParameterDO[]) lst.toArray(new ParameterDO[lst.size()]);
            tx.commit();

        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingParameterData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }

        return pa;
    }

    public Long createOrUpdateParameter(ParameterDO instance)
            throws PersistentObjectException {

        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        ParameterDO param = (ParameterDO) instance;
        String stmt = "from ParameterDO as param where param.name='"
                + param.getName() + "'";

        try {
            ParameterDO paramDB = (ParameterDO) session.createQuery(stmt)
                    .uniqueResult();
            if (paramDB == null) {
                param.setLastUpdatedTime(new Date());
                session.persist(param);
            } else {
                param.setId(paramDB.getId());
                param.setLastUpdatedTime(new Date());
                session.merge(param);
            }
            session.flush();
            tx.commit();

        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingParameterData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }

        return param.getId();

    }

    public ParameterDO getParameter(String name) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from ParameterDO as param where param.name='" + name
                + "'";

        ParameterDO pa = null;
        try {
            pa = (ParameterDO) session.createQuery(stmt).uniqueResult();
            tx.commit();

        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingParameterData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }

        return pa;
    }
    
  
}
