/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */

package org.wso2.solutions.identity.persistence.dao;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Expression;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.UserPersonalCertificateDO;

import java.util.List;

public class UserPersonalCertificateDAO extends BaseDAO {

    public UserPersonalCertificateDAO(HibernateConfig config) {
        super(config);
    }

    public UserPersonalCertificateDO[] getAllCertificateAliases(String userId) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        try {
            Criteria criteria = session
                    .createCriteria(UserPersonalCertificateDO.class);
            criteria.add(Expression.eq("userId", userId));
            
            List list =  criteria.list();
            return (UserPersonalCertificateDO[]) list
                    .toArray(new UserPersonalCertificateDO[list.size()]);
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages
                    .getMessage("errorUserPersonalCertificate");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
    }
    
}
