/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dao;

import java.util.Iterator;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.UserTrustedRPDO;

public class UserPersonalRelyingPartyDAO extends BaseDAO {

    public UserPersonalRelyingPartyDAO(HibernateConfig config) {
        super(config);
    }

    public UserTrustedRPDO[] getAllPersonalRelyingParties(
            String userId) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from UserTrustedRPDO as utrp where utrp.identifier.userId = '" 
            + userId + "'";

        UserTrustedRPDO[] rps = new UserTrustedRPDO[0];
        try {
            List lst = (List) session.createQuery(stmt).list();
            if(lst.size()>0){
                rps = (UserTrustedRPDO[])
                    lst.toArray(new UserTrustedRPDO[lst.size()]);
            }
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingClaimData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return rps;
    }
    
    public UserTrustedRPDO getPersonalRelyingParty(String userId,
            String hostName) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from UserTrustedRPDO as utrp where utrp.identifier.userId = '" 
            + userId + "' and utrp.identifier.hostName = '"+ hostName+"'";

        UserTrustedRPDO rp = null;
        try {
            rp = (UserTrustedRPDO)session.createQuery(stmt).uniqueResult();
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingClaimData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }

        return rp;
    }
    
    
    public UserTrustedRPDO[] getPersonalRelyingPartyByHostName(String hostName) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from UserTrustedRPDO as utrp where utrp.identifier.hostName = '"+ hostName+"'";

        UserTrustedRPDO[] rps = new UserTrustedRPDO[0];
        try {
            List lst = session.createQuery(stmt).list();
            rps = (UserTrustedRPDO[])lst.toArray(new UserTrustedRPDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorQuerryingClaimData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }

        return rps;
    }
}
