/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dataobject;

import java.util.Set;

public class ActionDO extends AbstractDataObject {

    private String actionId;
    
    private Set userActions;
    
    public final static String ACTION_USER_LOG_IN_UT = "User Login - Username Token";
    public final static String ACTION_USER_LOG_IN_CARD = "User Login - Info Card";
    public final static String ACTION_USER_LOG_OUT = "User Logged out";
    public final static String ACTION_USER_INFOCARD_SUBMIT = "User Register InfoCard";
    public final static String ACTION_USER_REGISTER = "InfoCard registration";
    public final static String ACTION_USER_DOWNLOAD_CARD = "Downloaded Card";
    public final static String ACTION_USER_ADD_RP = "Add trusted Relying Party";
    public final static String ACTION_CARD_ISSUE_FAILURE = "Issue Card Failure";
    public final static String ACTION_TOKEN_ISSUE_FAILURE = "Issue Token Failure";
    public final static String ACTION_USER_FAILURE = "User Failure";
    public final static String ACTION_USER_DOWNLOAD_OPENID_CARD = "Downloaded OpenID Information Card";
    public final static String ACTION_USER_LOG_IN_OPENID_CARD = "User Login - OpenID Information Card";
    public final static String ACTION_USER_LOG_IN_OPENID = "User Login - OpenID";
    public final static String ACTION_USER_LOG_IN_SELF_ISSUED_CARD= "User Login - Self issued Information Card";
    public final static String ACTION_USER_APPROVED_OPENID_RP_ALWAYS = "User approved OpenID RP always";
    public final static String ACTION_USER_APPROVED_OPENID_RP_ONCE = "User approved OpenID RP once";
    public final static String ACTION_USER_APPROVED_OPENID_RP_DENIED = "User denied OpenID RP";
    
    public final static String[] actions = { ACTION_USER_LOG_IN_UT,
                        ACTION_USER_LOG_IN_CARD,
                        ACTION_USER_LOG_OUT,
                        ACTION_USER_INFOCARD_SUBMIT,
                        ACTION_USER_REGISTER,
                        ACTION_USER_ADD_RP,
                        ACTION_USER_DOWNLOAD_CARD,
                        ACTION_USER_FAILURE,
                        ACTION_CARD_ISSUE_FAILURE,
                        ACTION_USER_DOWNLOAD_OPENID_CARD,
                        ACTION_USER_LOG_IN_OPENID_CARD,
                        ACTION_USER_LOG_IN_OPENID,
                        ACTION_USER_APPROVED_OPENID_RP_ALWAYS,
                        ACTION_USER_APPROVED_OPENID_RP_ONCE,
                        ACTION_USER_APPROVED_OPENID_RP_DENIED,
                        ACTION_USER_LOG_IN_SELF_ISSUED_CARD,
                        ACTION_TOKEN_ISSUE_FAILURE};            
           
    
    
    public String getActionId() {
        return actionId;
    }

    public void setActionId(String actionId) {
        this.actionId = actionId;
    }

    public Set getUserActions() {
        return userActions;
    }

    public void setUserActions(Set userActions) {
        this.userActions = userActions;
    }
    
    
}
