/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.solutions.identity.persistence.dataobject;


public class ClaimDO extends AbstractDataObject {

    public final static String DAFAULT_ATTR_ID = "__wso2-is-attr";

    private String uri = null;

    private String displayTag = null;

    private String description = null;

    private boolean simple = true;

    private boolean userEditable = true;

    private String attrId = DAFAULT_ATTR_ID;

    private boolean supported;    

    private DialectDO dialect;
    
    private String openIDTag;
    
    private boolean required;

    public String getOpenIDTag() {
        return openIDTag;
    }

    public void setOpenIDTag(String openIDTag) {
        this.openIDTag = openIDTag;
    }

    public String getAttrId() {
        return attrId;
    }

    public void setAttrId(String attrId) {
        this.attrId = attrId;
    }

 

    public boolean isSimple() {
        return simple;
    }

    public void setSimple(boolean simple) {
        this.simple = simple;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDisplayTag() {
        return displayTag;
    }

    public void setDisplayTag(String displayTag) {
        this.displayTag = displayTag;
    }

    public String getUri() {
        return this.uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    public boolean isUserEditable() {
        return userEditable;
    }

    public void setUserEditable(boolean userEditable) {
        this.userEditable = userEditable;
    }

    public boolean isSupported() {
        return supported;
    }

    public boolean isMapped() {
        return !DAFAULT_ATTR_ID.equals(this.attrId);
    }

    public void setSupported(boolean supported) {
        this.supported = supported;
    }

    public DialectDO getDialect() {
        return dialect;
    }

    public void setDialect(DialectDO dialect) {
        this.dialect = dialect;
    }

    public boolean isRequired() {
        return required;
    }

    public void setRequired(boolean required) {
        this.required = required;
    }

}
