/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dataobject;

import java.util.Set;

/**
 * A configured realm instance.
 */
public class RealmConfigurationDO extends AbstractDataObject {

    /**
     * The <code>org.wso2.usermanager.Realm</code> implementation this
     * information configures.
     */
    private RealmDO realm;

    /**
     * Name give to this instance of the configuration.
     */
    private String name;

    private Set configProperties;

    /**
     * This is the flag that marks this as the effective realm for the identity
     * provider.
     */
    private boolean effective = false;

    public RealmDO getRealm() {
        return realm;
    }

    public void setRealm(RealmDO realm) {
        this.realm = realm;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isEffective() {
        return effective;
    }

    public void setEffective(boolean effective) {
        this.effective = effective;
    }

    public Set getConfigProperties() {
        return configProperties;
    }

    public void setConfigProperties(Set properties) {
        this.configProperties = properties;
    }

}