/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dataobject;

import java.util.Set;

/**
 * Information about available <code>org.wso2.usermanager.Realm</code>
 * implementations.
 */
public class RealmDO extends AbstractDataObject {

    /**
     * Name of the <code>org.wso2.usermanager.Realm</code> implementation
     * class.
     */
    private String className;

    /**
     * Name of the configuration class
     */
    private String configClassName;

    /**
     * Configurations that uses this realm
     */
    private Set realmConfigurations;

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getConfigClassName() {
        return configClassName;
    }

    public void setConfigClassName(String configClassName) {
        this.configClassName = configClassName;
    }

    public Set getRealmConfigurations() {
        return realmConfigurations;
    }

    public void setRealmConfigurations(Set realmConfigurations) {
        this.realmConfigurations = realmConfigurations;
    }

    public String toString() {
        return this.className;
    }

}
