/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.solutions.identity.persistence.dataobject;

import java.util.HashSet;
import java.util.Set;

public class RelyingPartyDO extends AbstractDataObject {

    private Set ppidValues = new HashSet(); // one-many relationship between

    // RelyingParty and PPIDValue

    private String hostName = null;

    private String storeName = null;

    private String alias = null;
    
    private Set tokens = null;

    public String getAlias() {
        return alias;
    }

    public void setAlias(String alias) {
        this.alias = alias;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public void addPPIDValue(PPIDValueDO ppid) {
        ppidValues.add(ppid);
        ppid.setRelyingParty(this);
    }

    public Set getPpidValues() {
        return ppidValues;
    }

    public void setPpidValues(Set ppidValues) {
        this.ppidValues = ppidValues;
    }

    public String getHostName() {
        return hostName;
    }

    public void setHostName(String hostName) {
        this.hostName = hostName;
    }

    public Set getTokens() {
        return tokens;
    }

    public void setTokens(Set tokens) {
        this.tokens = tokens;
    }

}
