package org.wso2.solutions.identity.sts.saml;

import org.apache.rahas.RahasData;
import org.joda.time.DateTime;
import org.opensaml.xml.security.x509.X509Credential;
import org.w3c.dom.Element;
import org.wso2.solutions.identity.IdentityProviderException;
import org.wso2.solutions.identity.sts.IdentityProviderData;

/**
 * The builder pattern. Builder interface. Concrete implementations build
 * SAMLAssertions of different types.
 */
public interface SAMLTokenBuilder {

    void createStatement(IdentityProviderData ipData, RahasData rahasData)
            throws IdentityProviderException;

    void createSAMLAssertion(DateTime notAfter, DateTime notBefore,
            String assertionId) throws IdentityProviderException;

    void setSignature(String signatureAlgorithm, X509Credential cred)
            throws IdentityProviderException;

    void marshellAndSign() throws IdentityProviderException;

    Element getSAMLasDOM() throws IdentityProviderException;
}
