package org.wso2.solutions.identity.users;

import org.wso2.usermanager.UserManagerException;
import org.wso2.usermanager.readwrite.DefaultRealm;

/**
 * Extends base class functionality to introduce multiple profile support.
 */
public class IdentityDefaultRealm extends DefaultRealm {

    /**
     * Overrides the base functionality set our own UserStoreAdmin and
     * UserStoreReader.
     */
    public void init(Object configBean) throws UserManagerException {
        super.init(configBean);
        usAdmin = new IdentityDefaultUserStoreAdmin(dataSource, strategyObject);
        usReader = new IdentityDefaultUserStoreReader(dataSource,
                strategyObject);
    }

    /**
     * @return IdentityUserStoreAdmin
     */
    public IdentityUserStoreAdmin getIdentityUserStoreAdmin() {
        return (IdentityUserStoreAdmin) usAdmin;
    }

    /**
     * @return IdentityUserStoreReader
     */
    public IdentityUserStoreReader getIdentityUserStoreReader() {
        return (IdentityUserStoreReader) usReader;
    }

}
