package org.wso2.solutions.identity.users;

import java.util.Map;

import org.wso2.usermanager.UserManagerException;

/**
 * This interface adds the functionality related to multiple profiles. A given
 * user can have multiple profiles with different attribute values. This
 * contains methods corresponding to adding attribute values to user profiles.
 */
public interface IdentityUserStoreAdmin {

    /**
     * This sets user properties corresponding to the given user name and the
     * profile name.
     * @param userName Unique user name
     * @param properties Profile properties
     * @param profileName Name of the profile
     * @throws UserManagerException
     */
    public void setUserProperties(String userName, Map<String,String> properties,
            String profileName) throws UserManagerException;
    
    /**
     * This updates user properties corresponding to the given user name and the
     * profile name.
     * @param userName Unique user name
     * @param properties Profile properties
     * @param profileName Name of the profile
     * @throws UserManagerException
     */
    public void updateUserProperties(String userName, Map<String,String> properties,
            String profileName) throws UserManagerException;

}
